# UserTesting APIs Documentation > APIs to help integrate the UserTesting solution across applications to allow our customers to share data and get feedback seamlessly. ## Guides - [Getting Started](https://developer.usertesting.com/docs/getting-started.md): _Using the Results API (v2)_ - [Authorization](https://developer.usertesting.com/docs/authorization.md): _How to generate and use access tokens for your endpoint requests_ - [How to Obtain a Test ID (UUID)](https://developer.usertesting.com/docs/how-to-obtain-a-testid-uuid.md): _Use the UserTesting UI to Find Test IDs._ - [Overview](https://developer.usertesting.com/docs/overview.md): _Tutorials based on use cases_ - [Create an Automated Pipeline](https://developer.usertesting.com/docs/tutorial.md): _Build an Automated Research Data Pipeline (Warehouse Sync)_ - [Build a UX Metrics Dashboard](https://developer.usertesting.com/docs/ux-metrics-dashboard.md): _Create a UX metrics dashboard with QXscore to track experience quality_ - [Stream Insights into Slack or Jira](https://developer.usertesting.com/docs/stream-insights-into-slack-or-jira.md): _Near real-time polling_ - [Generate Video Transcript Analysis](https://developer.usertesting.com/docs/video-transcript-analysis.md): _Run AI Analysis on Transcripts with an LLM_ - [Process Session Videos at Scale](https://developer.usertesting.com/docs/download-and-manage-session-videos-at-scale.md): _Securely download and manage session videos at scale using temporary pre-signed URLs_ - [Model Session Details & Demographics](https://developer.usertesting.com/docs/understand-and-model-session-details-demographics.md): _Understand and model session-level details and participant demographics_ - [Download a Highlight Reel from a Test Result](https://developer.usertesting.com/docs/download-a-highlight-reel-from-a-test-result.md): _Learn how to list the highlight reels available for a test result, request a selected highlight reel by ID, poll while the reel is being generated, and download the reel when a temporary URL is returned_ - [Not a Developer?](https://developer.usertesting.com/docs/not-a-developer.md): _Introduction for non-technical users._ ## API Reference - [Find all sessions in a test](https://developer.usertesting.com/reference/sessionresultscontroller_getsessionsummaryresults.md): Returns a paginated list of summaries for each completed session in a test. Each summary includes the session ID, status, and timestamps. In the response, sessions are sorted in descending order, i.e., from newest to oldest. _Compatibility:_ - All tests with the "STUDYV2" type are compatible. These include tests with the following product types: - "SURVEY" (survey) - "LIVE_CONVERSATION" (non-classic live conversation) - "NON_THINK_OUT_LOUD" (interaction test) - "THINK_OUT_LOUD" (think-out-loud test) - Go to [How to Obtain a Test ID (UUID)](https://developer.usertesting.com/docs/how-to-obtain-a-testid-uuid) for details. _Best practices:_ - Always use pagination query parameters (_limit_ and _offset_) along with the appropriate logic to ensure all sessions are retrieved. - Use the response data from _limit_, _offset_, and _totalCount_ in the _meta.pagination_ property to calculate the number of pagination iterations (API requests) needed to collect all sessions in the test. _Use case examples:_ - For an example on near real-time polling, go to [Stream Insights into Slack or Jira](https://developer.usertesting.com/v2.0/docs/stream-insights-into-slack-or-jira). - For an example on how to add session summaries into an automated research data pipeline, go to [Create an Automated Pipeline](https://developer.usertesting.com/v2.0/docs/tutorial). - [Retrieve session details (v3)](https://developer.usertesting.com/reference/sessionresultsv3controller_getsessionresults.md): Returns detailed information about a session, including participant demographics, task-group metadata, and individual task responses. _Compatibility:_ - All sessions found within tests with the "STUDYV2" type are compatible. These include tests from the following product types: - "SURVEY" (survey) - "LIVE_CONVERSATION" (non-classic live conversation) - "NON_THINK_OUT_LOUD" (interaction test) - "THINK_OUT_LOUD" (think-out-loud test) - Go to [How to Obtain a Test ID (UUID)](https://developer.usertesting.com/docs/how-to-obtain-a-testid-uuid) for details. _Use case examples:_ - For an example on how to understand and model session-level details and participant demographics, go to [Model Session Details & Demographics](https://developer.usertesting.com/v2.0/docs/understand-and-model-session-details-demographics). - For an example on how to add session details into an automated research data pipeline, go to [Create an Automated Pipeline](https://developer.usertesting.com/v2.0/docs/tutorial). - For an example on near real-time polling, go to [Stream Insights into Slack or Jira](https://developer.usertesting.com/v2.0/docs/stream-insights-into-slack-or-jira). - [Retrieve a video transcript](https://developer.usertesting.com/reference/sessionresultscontroller_gettranscriptvtt.md): Returns the video transcript of a test session in [Web Video Text Tracks (WebVTT)](https://developer.mozilla.org/en-US/docs/Web/API/WebVTT_API/Web_Video_Text_Tracks_Format) format. _Compatibility:_ - Sessions must be found within tests with the "STUDYV2" type and belong to one of the following product types: - "LIVE_CONVERSATION" (non-classic live conversation) - "THINK_OUT_LOUD" (think-out-loud test). - Go to [How to Obtain a Test ID (UUID)](https://developer.usertesting.com/docs/how-to-obtain-a-testid-uuid) for details. _Best practices:_ - If needed, you can copy and paste the string and save it as a text file with the VTT extension. _Use case examples:_ - For an example on how to run AI analysis on transcripts with an LLM, go to [Generate Video Transcript Analysis](https://developer.usertesting.com/v2.0/docs/video-transcript-analysis). - For an example of how to add transcripts into an automated research data pipeline, go to [Create an Automated Pipeline](https://developer.usertesting.com/v2.0/docs/tutorial). - [Obtain a video download link](https://developer.usertesting.com/reference/sessionresultscontroller_getvideodownloadurl.md): Returns a pre-signed URL to download a test session video. The URL is valid for one hour; after expiration, request a new URL. _Compatibility:_ - Sessions must be found within tests with the "STUDYV2" type and belong to one of the following product types: - "LIVE_CONVERSATION" (non-classic live conversation) - "NON_THINK_OUT_LOUD" (interaction test) - "THINK_OUT_LOUD" (think-out-loud test). - Go to [How to Obtain a Test ID (UUID)](https://developer.usertesting.com/docs/how-to-obtain-a-testid-uuid) for details. _Use case examples:_ - For an example on how to securely download and manage session videos at scale using pre-signed URLs, go to [Process Session Videos at Scale](https://developer.usertesting.com/v2.0/docs/download-and-manage-session-videos-at-scale). - For an example on how to integrate video downloads into an automated research data pipeline, go to [Create an Automated Pipeline](https://developer.usertesting.com/v2.0/docs/tutorial). - [Find all clips for a session video](https://developer.usertesting.com/reference/sessionresultscontroller_getclips.md): Returns the clips created from a session video, including clip timing, media flags, layout, and video region metadata. _Compatibility:_ - Sessions must be found within tests with the "STUDYV2" type and belong to one of the following product types that support session video clips: - "LIVE_CONVERSATION" (non-classic live conversation) - "NON_THINK_OUT_LOUD" (interaction test) - "THINK_OUT_LOUD" (think-out-loud test). - Go to [How to Obtain a Test ID (UUID)](https://developer.usertesting.com/docs/how-to-obtain-a-testid-uuid) for details. - [Obtain a clip download link](https://developer.usertesting.com/reference/sessionresultscontroller_getclipdetails.md): Returns the details of a clip and a link to download it. If the clip is still being prepared, the response returns a status of `GENERATING` and no link. Call this endpoint again every few seconds until the status becomes `GENERATED`, then use the `clipUrl` to download the clip. The link is valid for 15 minutes; after it expires, call the endpoint again to get a new one. _Compatibility:_ - Sessions must be found within tests with the "STUDYV2" type and belong to one of the following product types that support session video clips: - "LIVE_CONVERSATION" (non-classic live conversation) - "NON_THINK_OUT_LOUD" (interaction test) - "THINK_OUT_LOUD" (think-out-loud test). - Go to [How to Obtain a Test ID (UUID)](https://developer.usertesting.com/docs/how-to-obtain-a-testid-uuid) for details. - [Obtain QXscores for a test](https://developer.usertesting.com/reference/testresultscontroller_getqxscoreresponse.md): Calculates the Quality of Experience Score (QXscore) for an [Interaction test](https://help.usertesting.com/hc/en-us/articles/23596817555101-Interaction-tests) based on all completed sessions. The response includes detailed component and subcomponent values that contribute to the overall QXscore. _Compatibility:_ - Compatible with interaction tests, i.e., tests with the "STUDYV2" type and "NON_THINK_OUT_LOUD" product type. - Go to [How to Obtain a Test ID (UUID)](https://developer.usertesting.com/docs/how-to-obtain-a-testid-uuid) for details. _Note:_ - A _QXscore_ is a reliable benchmark metric for evaluating the quality of an experience. This composite score combines behavioral data from navigation tasks with attitudinal data from a standardized questionnaire to effectively balance participants' actions and opinions. [Learn more about QXscore](https://help.usertesting.com/hc/en-us/articles/22818008129565-QXscore). _Use case example:_ - For an example on how to create a UX metrics dashboard with QXscore to track experience quality, go to [Build a UX Metrics Dashboard](https://developer.usertesting.com/v2.0/docs/ux-metrics-dashboard). - [Find all highlight reels for a test](https://developer.usertesting.com/reference/testresultscontroller_gethighlightreels.md): Returns all highlight reels for the test. Each highlight reel includes its ID, name, duration, last updated timestamp, clip count, and whether all test clips are included in the reel. _Compatibility:_ - Tests must be of the "STUDYV2" type and belong to one of the following product types: - "LIVE_CONVERSATION" (non-classic live conversation) - "NON_THINK_OUT_LOUD" (interaction test) - "THINK_OUT_LOUD" (think-out-loud test). - Go to [How to Obtain a Test ID (UUID)](https://developer.usertesting.com/docs/how-to-obtain-a-testid-uuid) for details. _Notes:_ - Use the returned highlight reel ID to request highlight reel download link from the "GET /api/v2/testResults/{testId}/highlightreels/{reelId}" endpoint. - [Obtain a highlight reel download link](https://developer.usertesting.com/reference/testresultscontroller_getreeldetails.md): Returns the details of a highlight reel and a link to download it. If the highlight reel is still being prepared, the response returns a status of `GENERATING` and no link. Call this endpoint again every few seconds until the status becomes `GENERATED`, then use the `reelUrl` to download the highlight reel. The link is valid for 15 minutes; after it expires, call the endpoint again to get a new one. _Compatibility:_ - Tests must be of the "STUDYV2" type and belong to one of the following product types: - "LIVE_CONVERSATION" (non-classic live conversation) - "NON_THINK_OUT_LOUD" (interaction test) - "THINK_OUT_LOUD" (think-out-loud test). - Go to [How to Obtain a Test ID (UUID)](https://developer.usertesting.com/docs/how-to-obtain-a-testid-uuid) for details.